<style type="text/css">
	.w200 { width: 200px !important }
	.w150 { width: 150px !important }
	.ml100 {margin-left: 100px !important }
	.ml115 {margin-left: 115px !important }
	.mt10 { margin-top: 10px !important }
	.mr30 {margin-right: 30px !important}
	
	.gotm-header {
		text-align: center;
	}
	
	.gotm-note-text{
		border: 2px solid #000000;
		margin: 0 auto 20px;
		padding: 10px;
		text-align: center;
		width: 800px;
		font-weight: bold;
	}
	
	.form .vindent2 {margin-top: 0px !important}
	
	.gotm-header span {
		font-weight: bold;
		font-size: 14px;
	}
	.gotd_package_select_bg {
		background: url('/img/gotd_package_select_bg.png') repeat-x;
		background-color: #cbe8f8;
		width: 426px;
		margin: 20px auto;
		padding: 10px 10px 0 10px;
		border: 1px solid #caebfd
	}
	.gotd_package_select_bg .select-row {
		margin: 0 20px 10px 0;
		float: right;
	}
	.select-row label{
		width: auto;
		margin-right: 5px;
	}
	
	#calendar-container {
		height: 630px;
		margin-top: 15px;
	}
	#calendar-container .sep {
		border-top: 1px solid #eee;
		margin: 10px 0 10px 0
	}
	#calendar {
		border: 3px solid #2e2e2e;
		margin: 30px auto;
		overflow: hidden;
		width: 672px;
	}
	#calendar .ii {
		float: left;
		width: 672px;
	}
	#month {
		height: 38px;
		background: url('/img/calendar_month_bg.png');
		text-align: center;
		position: relative;
		padding-top: 10px;
	}
	#month span {
		font-size: 24px;
		font-weight: bold;
		color: #e0e0e0;
	}
	#prev {
		cursor: pointer;
		position: absolute;
		background: url('/img/calendar_prev.png');
		height: 12px;
		width: 11px;
		top: 18px;
		left: 25px;
	}
	#next {
		cursor: pointer;
		position: absolute;
		background: url('/img/calendar_next.png');
		height: 12px;
		width: 11px;
		top: 18px;
		right: 25px;
	}
	#calendar .weekdays {
		height: 35px;
		background: url('/img/calendar_weekdays_bg.png') repeat-x;
		border-bottom: 1px solid #bbb;
	}
	#calendar span.weekday {
		color: #8d8d8d;
		font-size: 14px;
		float: left;
		padding: 8px 21px;
	}
	#calendar .cell-wrapper {
		float: left;
		padding: 1px 0 0 1px;
	}
	#calendar span.cell {
		float: left;
		width: 94px;
		height: 55px;
		color: #b4b3b3;
		font-size: 25px;
		text-align: center;
		border-bottom: 1px solid #bbbbbb;
		border-right: 1px solid #bbbbbb;
		background: url('/img/calendar_cell_bg_passive.png') repeat-x;
		line-height: 2em;
	}
	
	#calendar span.available:hover {
		background: url('/img/calendar_cell_bg_hover.png') repeat-x !important;
	}
	#calendar span.selected {
		color: #4f4f4f !important;
		background: url('/img/calendar_cell_bg_selected.png') repeat-x !important;
	}
	#calendar span.available {
		color: #4f4f4f !important;
		background: url('/img/calendar_cell_bg.png') repeat-x;
		cursor: pointer;
	}
	#calendar span.available.next-month-day {
		background: url('/img/calendar_cell_bg_passive.png') repeat-x !important;
	}
	
	#calendar span.available.prev-month-day {
		background: url('/img/calendar_cell_bg_passive.png') repeat-x !important;
	}
	
	#calendar span.booked {
		background: url('/img/calendar_cell_bg_booked.png') repeat-x;
		color: #fff;
	}
	
	#legend {
		float: right;
		margin-right: 140px;
	}
	#legend span {
		float: right;
		margin-right: 5px;
	}
	#legend .booked-legend {
		width: 20px;
		height: 20px;
		background-color: #bd0000;
		float: right;
		margin-top: -3px;
	}
	#pay {
		cursor: pointer;
		text-decoration: none;
		float:left;
		margin: 10px 340px;
		line-height: 48px;
	}
	#pay .i {
		background: url('/img/gotd_button.jpg') 0 0;
		height: 52px;
		padding-left: 27px;
	}
	#pay .ii {
		background: url('/img/gotd_button.jpg') 100% -52px;
		height: 52px;
		padding-right: 27px;
	}
	#pay span {
		font-weight: bold;
		color: #fff;
		font-size: 14px;
	}
	
	form .error {
		color: red;
		font-weight: bold;
		clear: both
	}
</style>

<div class="gray-box form">
	<? 
	$independent_error_message = "";
	if ( ! $this->is_agency ) {
		if ( ! $this->escort_package ) {
			$independent_error_message = __('active_package_required');
		} elseif ( $this->escort_package['escort_status'] == Model_EscortsV2::ESCORT_STATUS_OWNER_DISABLED ) {
			$independent_error_message = __('gotd_profile_owner_disabled');
		} elseif ( $this->escort_package['status'] == 6 ) { //Suspended
			$independent_error_message = __('gotd_package_suspended');
		}
	}
	
	?>
	<? if ( strlen($independent_error_message) ): ?>
	<div class="vindent2">
		<p style="font-size: 12px; margin-bottom: 10px; font-weight: bold; color: red"><?= $independent_error_message ?></p>
	</div>
	<? else: ?>
	<form method="post">
		<div class="vindent2">
			<div class="gotm-header">
				<span><?= strtoupper(__('gotd_header'))?></span>
			</div>
			<div class="gotd_package_select_bg">
				<div class="select-row">
					<label><?= __('select_region') ?></label>
					<select class="w200" name="city_id" id="city-id">
						<option value="">---</option>
						<? foreach($this->grouped_cities as $region_title => $cities): ?>
						<optgroup label="<?= $region_title ?>">
							<? foreach($cities as $city): ?>
							<option value="<?= $city->id ?>" <?= $this->data['city_id'] && $this->data['city_id'] == $city->id ? 'selected="selected"' : '' ?>><?= $city->title ?></option>
							<? endforeach; ?>
						</optgroup>
						<? endforeach; ?>
					</select>
					<? if ( isset($this->gotd_errors['city_id']) ): ?>
					<div class="error fright mr30 mt10"><?= $this->gotd_errors['city_id'] ?></div>
					<? endif; ?>
				</div>
				
				<div class="clear"></div>
				<? if ( $this->is_agency ): ?>
				<div class="select-row">
					<label><?= __('select_escort') ?></label>
					<select class="w200" name="escort_id" id="escort-id">
						<option value="">---</option>
						<? foreach($this->escorts as $escort): ?>
						<option value="<?= $escort['id'] ?>" <?= $this->data['escort_id'] && $this->data['escort_id'] == $escort['id'] ? 'selected="selected"' : '' ?>><?= $escort['showname'] ?></option>
						<? endforeach; ?>
					</select>
					<? if ( isset($this->gotd_errors['escort_id']) ): ?>
					<div class="error fright mr30 mt10"><?= $this->gotd_errors['escort_id'] ?></div>
					<? endif; ?>
				</div>
				<div class="clear"></div>
				<? endif; ?>
			</div>
			<div class="clear"></div>
			<div class="gotm-note-text" style="text-align:left">
				<span class="red"><?= __('gotd_note_text'); ?></span>
			</div>	
		</div>
		<? 
			$curr_year = date('Y', time());
			$years_count = 2;
			$width = 672;
			$curr_month = (int)date('n', time());
		?>

		<fieldset id="calendar-container">
			<legend>Calendar</legend>
			<input type="hidden" name="date" id="date" value=""/>
			<? if ( isset($this->gotd_errors['date']) ): ?>
				<div class="error fleft ml115 mt10"><?= $this->gotd_errors['date'] ?></div>
			<? endif; ?>
			<div id="calendar">
				<div id="month">
					<a id="prev"></a>
					<span><?= date('F', time()) . ' ' . $curr_year ?></span>
					<a id="next"></a>
				</div>
				<div class="i" style="width: <?= $years_count * 12 * $width; ?>px">
					<? for($year = $curr_year; $year < $curr_year + $years_count; $year++): ?>
						<?
						if ( $year == $curr_year ) {
							$months_from = $curr_month;
						} else {
							$months_from = 1;
						}
						
						/*if ( $this->data['date'] ) {
							$margin_offset = (date('m', $this->data['date']) - $months_from) * $width;
						}*/
						?>
						<? for($i = $months_from; $i <= 12; $i++): ?>
						<div class="ii month-<?= $i . '-' . $year ?>">
							<input type="hidden" value="<?= date('F', mktime(0, 0, 0, $i, 1, $year)) . ' ' . $year ?>"/>
							<div class="weekdays">
								<span class="weekday">Monday</span>
								<span class="weekday">Tuesday</span>
								<span class="weekday">Wednsday</span>
								<span class="weekday">Thursday</span>
								<span class="weekday">Friday</span>
								<span class="weekday">Saturday</span>
								<span class="weekday">Sunday</span>
							</div>
							<div class="days">
								<? /* PREPENDING DAYS FROM LAST MONTH */ ?>
								<? 
									$first_weekday = date('w', mktime(0, 0, 0, $i, 1, $year)); 
									if ( $first_weekday == 0 ) $first_weekday = 7; // fixing sunday = 7
									$days_to_prepend = 7 - ( (7 - $first_weekday) + 1);
									$days_in_previous_month = cal_days_in_month(CAL_GREGORIAN, $i - 1 > 0 ? $i - 1 : 12, $i - 1 > 0 ? $year : $year - 1);
								?>
								<? for($k = $days_in_previous_month - ($days_to_prepend - 1 ); $k <= $days_in_previous_month; $k++): ?>
								<?
								$class = '';
								$d_string = date('Y-m-d', mktime(0, 0, 0, $i - 1, $k, $year));
								if ( $this->is_agency ) {
									if ( $this->data['escort_id'] && $d_string >= date('Y-m-d', time()) && $d_string >= date('Y-m-d', $this->escorts[$this->data['escort_id']]['date_activated']) && $d_string <= date('Y-m-d', $this->escorts[$this->data['escort_id']]['expiration_date']) ) {
										$class = 'available stat-avail';
									}
								} else {
									if ( $d_string >= date('Y-m-d', $this->escort_package['date_activated']) && $d_string <= date('Y-m-d', $this->escort_package['expiration_date']) ) {
										$class = 'available stat-avail';
									}
								}
								?>
								<div class="cell-wrapper">
									<span class="cell prev-month-day <?= date('Y-n-j', mktime(0, 0, 0, $i - 1 > 0 ? $i - 1 : 12, $k, $i - 1 > 0 ? $year : $year - 1 )) ?> <?= $class ?>"><?= $k ?></span>
								</div>
								<? endfor; ?>
								<? /*  */ ?>

								<? /* FILLING DAYS OF MONTH */ ?>
								<? $days_count = cal_days_in_month(CAL_GREGORIAN, $i, $year) ?>
								<? for($y = 1; $y <= $days_count; $y++): ?>
								
								<?
								$class = '';
								$d_string = date('Y-m-d', mktime(0, 0, 0, $i, $y, $year));
								
								if ( $this->is_agency ) {
									if ( $this->data['escort_id'] && $d_string >= date('Y-m-d', time()) && $d_string >= date('Y-m-d', $this->escorts[$this->data['escort_id']]['date_activated']) && $d_string <= date('Y-m-d', $this->escorts[$this->data['escort_id']]['expiration_date']) ) {
										$class = 'available stat-avail';
									}
								} else {
									if ( $d_string >= date('Y-m-d', time()) && $d_string >= date('Y-m-d', $this->escort_package['date_activated']) && $d_string <= date('Y-m-d', $this->escort_package['expiration_date']) ) {
										$class = 'available stat-avail';
									}
								}
								
								if ( $this->data['date'] ) {
									if ( $d_string == date('Y-m-d', $this->data['date']) )  {
										$class = 'selected';
									}
								}

								if ( $this->data['city_id'] ) {
									foreach($this->city_also_check as $ct) {
										if ( count( $this->booked_days[$ct] ) ) {
											foreach($this->booked_days[$ct] as $dt) {
												if ($d_string == date('Y-m-d', strtotime($dt['date'])) )  {
													$class = 'booked';
													break;
												}
											}
										}
									}
								}
								?>
								<div class="cell-wrapper">
									<span class="cell <?= $class ?> <?= date('Y-n-j', mktime(0, 0, 0, $i, $y, $year)) ?>"><?= $y ?></span>
								</div>
								<? endfor; ?>
								<? /* */ ?>

								<? /* APPENDING DAYS FROM NEXT MONTH */ ?>
								<?
									$days_to_append = 42 - ($days_count + $days_to_prepend);
								?>

								<? for($k = 1; $k <= $days_to_append; $k++): ?>
								<?
								$class = '';
								$d_string = date('Y-m-d', mktime(0, 0, 0, $i + 1, $k, $year));
								if ( $this->is_agency ) {
									if ( $this->data['escort_id'] && $d_string >= date('Y-m-d', time()) && $d_string >= date('Y-m-d', $this->escorts[$this->data['escort_id']]['date_activated']) && $d_string <= date('Y-m-d', $this->escorts[$this->data['escort_id']]['expiration_date']) ) {
										$class = 'available stat-avail';
									}
								} else {
									if ( $d_string >= date('Y-m-d', $this->escort_package['date_activated']) && $d_string <= date('Y-m-d', $this->escort_package['expiration_date']) ) {
										$class = 'available stat-avail';
									}
								}
								?>
								<div class="cell-wrapper">
									<span class="cell next-month-day <?= date('Y-n-j', mktime(0, 0, 0, $i + 1 > 12 ? 1 : $i + 1, $k, $i + 1 > 12 ? $year + 1 : $year)) ?> <?= $class ?>"><?= $k ?></span>
								</div>
								<? endfor; ?>
								<? /* */ ?>
							</div>
						</div>
						<? endfor; ?>
					<? endfor; ?>
				</div>
			</div>
			<div id="legend">
				<div>
					<div class="booked-legend"></div><span><?= __('already_booked') ?></span>
				</div>
			</div>
			<div class="clear"></div>
			<div class="sep"></div>
			<a id="pay">
				<div class="i">
					<div class="ii"><span><?= strtoupper(__('continue_pay')) ?></span></div>
				</div>
			</a>
		</fieldset>
	</form>
	<? endif; ?>
</div>

<input type="hidden" id="booked-days" value='<?= json_encode($this->booked_days); ?>'/>
<input type="hidden" id="escorts" value='<?= json_encode($this->escorts); ?>'/>
<input type="hidden" id="region-relations" value='<?= json_encode($this->region_relations); ?>'/>

<script type="text/javascript">
	var step = <?= $width ?>;
	var currMonth = <?= $curr_month ?>;
	var currYear = <?= $curr_year ?>;
	var yearsCount = <?= $years_count ?>;
	var currMargin = 0;
	var escortPackage = <?= json_encode($this->escort_package) ?>; // For independent escort
	
	var fx = new Fx.Tween($$('#calendar .i')[0], {
		duration: 'short',
		transition: 'linear',
		link: 'cancel',
		property: 'margin-left'
	});
	
	window.addEvent('domready', function(){
		var bookedDays = JSON.decode($('booked-days').get('value'));
		var escorts = JSON.decode($('escorts').get('value'));
		var regionRelations = JSON.decode($('region-relations').get('value'));
		
		//For independent escort
		if ( escortPackage ) {
			currentDate = new Date();
			dateActivated = new Date(escortPackage.date_activated * 1000);
			
			monthsToShift = monthDiff(currentDate, dateActivated);
			if ( monthsToShift ) {
				fx.start(currMargin, currMargin - monthsToShift * step);
				currMargin -= monthsToShift * step;
				currMonth += monthsToShift;
				if ( currMonth > 12 ) {
					currMonth = 12 - currMonth;
					currYear += 1; 
					yearsCount -= 1;
				}
				setMonthTitle(currMonth, currYear);
			}
		}
		
		$('city-id').addEvent('change', function() {
			$$('#calendar span.selected').removeClass('selected').addClass('available');
			if ( ! this.get('value') ) {
				$$('#calendar span.booked').each(function(el) {
					if ( el.hasClass('stat-avail')  ) {
						el.addClass('available');
					}
				});
				$$('#calendar span').removeClass('booked');
				
				return;
			}
			
			/*$$('#calendar span.booked').addClass('available').addClass('stat-avail');
			$$('#calendar span.booked').removeClass('booked');*/
			
			$$('#calendar span.stat-avail.booked').addClass('available');
			$$('#calendar span.booked').removeClass('booked');
			
			var month, day, year;
			var citiesToCheck = [this.get('value')];
			if ( regionRelations[this.get('value')] ) {
				citiesToCheck = regionRelations[this.get('value')]
			}
			citiesToCheck.each(function(ct) {
				if ( bookedDays[ct] ) {
					bookedDays[ct].each(function(it) {
						date = it.date.split('-');

						month = date[1];
						day = date[2];
						year = date[0];
						
						//Removing leading 0 if necessary
						if ( day.charAt(0) == "0" ) {
							day = day.substr(1, day.length - 1);
						}
						if ( month.charAt(0) == "0" ) {
							month = month.substr(1, month.length - 1);
						}
						
						$$('.' + year + '-' + month + '-' + day).removeClass('available').addClass('booked');
					})
				}
			});
		});
		
		
		if ( $defined($('escort-id')) ) {
			$('escort-id').addEvent('change', function() {
				
				$$('#calendar span.selected').removeClass('selected').addClass('available');
				$$('#calendar .ii span').removeClass('available').removeClass('stat-avail');
				if ( ! this.get('value') ) {
					return;
				}
				
				escort = escorts[this.get('value')];
				expirationDate = new Date(escort.expiration_date * 1000);
				dateActivated = new Date(escort.date_activated * 1000);
				currentDate = new Date();
				
				if ( currentDate > dateActivated ) dateActivated = currentDate;
				
				
				daysInRange = getDates(dateActivated, expirationDate);
				
				var month, day, year;
				daysInRange.each(function(date) {
					var month = date.getMonth() + 1;
					var day = date.getDate();
					var year = date.getFullYear();
					
					$$('.' + year + '-' + month + '-' + day).each(function(el) {
						el.addClass('stat-avail');
						if ( ! el.hasClass('booked') ) {
							el.addClass('available');
						}
					});
				});
				
				monthsToShift = monthDiff(currentDate, dateActivated);
				if ( monthsToShift ) {
				
					fx.start(currMargin, currMargin - monthsToShift * step);
					currMargin -= monthsToShift * step;
					currMonth += monthsToShift;
					if ( currMonth > 12 ) {
						currMonth = 12 - currMonth;
						currYear += 1; 
						yearsCount -= 1;
					}
					setMonthTitle(currMonth, currYear);
				}
			});
		}
		
		$('prev').addEvent('click', function(e) {
			if ( currMargin == 0 ) return;
			
			fx.start(currMargin, currMargin + step);
			currMargin += step;
			currMonth -= 1;
			if ( currMonth == 0 ) {
				currMonth = 12;
				currYear -= 1;
				yearsCount += 1;
			}
			setMonthTitle(currMonth, currYear);
		});
		
		$('next').addEvent('click', function(e) {
			if ( currMonth == 12 && yearsCount == 1 ) return;
			
			fx.start(currMargin, currMargin - step);
			currMargin -= step;
			currMonth += 1;
			if ( currMonth > 12 ) {
				currMonth = 1;
				currYear += 1; 
				yearsCount -= 1;
			}
			setMonthTitle(currMonth, currYear);
		});
		
		$$('.days span').addEvent('click', function() {
			if ( ! this.hasClass('available') ) { return; }
			
			if ( this.hasClass('next-month-day') ) {
				$('next').fireEvent('click');
				clas = this.get('class');
				clas = clas.replace('cell', '');
				clas = clas.replace('next-month-day', '');
				clas = clas.replace('available', '');
				clas = clas.replace('stat-avail', '');
				clas = clas.replace(/\s/g,'');
				
				$$('.' + clas).getLast().fireEvent('click');
				
				return;
			}
			
			if ( this.hasClass('prev-month-day') ) {
				$('prev').fireEvent('click');
				clas = this.get('class');
				clas = clas.replace('cell', '');
				clas = clas.replace('prev-month-day', '');
				clas = clas.replace('available', '');
				clas = clas.replace('stat-avail', '');
				clas = clas.replace(/\s/g,'');
				
				$$('.' + clas)[0].fireEvent('click');
				
				return;
			}
			
			$$('.days span.selected').addClass('available').removeClass('selected');
			this.removeClass('available').addClass('selected');
		});
		
		$('pay').addEvent('click', function() {
			if ( $$('span.selected').length ) {
				//-->Getting selected day
				selectedDay = $$('span.selected')[0].get('html').toInt();
				if ( selectedDay < 1 || selectedDay > 31 ) {
					alert('Invalid date');
				}
				//<--

				//-->Getting selected year and month
				date = $$('span.selected')[0].getParent('.ii').getProperty('class');
				date = date.replace('ii ', '');
				date = date.split('-').slice(1, 3);
				//<--
				
				//$('date').set('value', Date.UTC(date[1], date[0] - 1, selectedDay) / 1000);
				$('date').set('value', [date[1], date[0], selectedDay].join(',') );
			}
			
			$$('form')[0].submit();
		});
		
		
		
	});
	
	function setMonthTitle(month, year) {
		if ( $$('.month-' + month + '-' + year)[0] ) {
			$$('#month span')[0].set('html', $$('.month-' + month + '-' + year)[0].getElement('input').get('value'));
		}
	}
	
	Date.prototype.addDays = function(days) {
		var dat = new Date(this.valueOf())
		dat.setDate(dat.getDate() + days);
		return dat;
	}
	
	function getDates(startDate, stopDate) {
		var dateArray = new Array();
		var currentDate = startDate;
		while (currentDate < stopDate.addDays(1)) {
			dateArray.push( new Date (currentDate) )
			currentDate = currentDate.addDays(1);
		}
		return dateArray;
    }
	
	function monthDiff(d1, d2) {
		var months;
		months = (d2.getFullYear() - d1.getFullYear()) * 12;
		months -= d1.getMonth() + 1;
		months += d2.getMonth();
		
		return months <= 0 ? 0 : months;
	}
	
</script>